﻿namespace HelloWorld;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Linq,
  System.Windows.Forms,
  System.ComponentModel,
  Steema.TeeChart.Pocket;


type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  MainForm = partial class(System.Windows.Forms.Form)
  private
    method button1_Click(sender: System.Object; e: System.EventArgs);

    method button2_Click(sender: System.Object; e: System.EventArgs);
    method timer1_Tick(sender: System.Object; e: System.EventArgs);
    method MainForm_Load(sender: System.Object; e: System.EventArgs);
    method monthCalendar1_DateChanged(sender: System.Object; e: System.Windows.Forms.DateRangeEventArgs);
    method button3_Click(sender: System.Object; e: System.EventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;
    method GetAppPath: String;
    method Kalenderwoche(datum :DateTime ): integer;
    Jetzt : datetime;

  end;

implementation

uses
  //Steema.TeeChart.Pocket;
   System.Globalization, system.Data.SqlServerCe,Steema.TeeChart.Pocket,Steema.TeeChart.Styles ;  

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();
  // var  tChart1 : Steema.TeeChart.Pocket.TChart := new Steema.TeeChart.Pocket.TChart ;
  // tChart1 := new TChart;
  {
  c.Width :=200;
  c.Height :=150;
  c.Top :=50;
  c.Left :=10;
  //c.Series.Add(new TeeChart.Styles.HorizBar()).FillSampleValues();
  //c[0].ColorEach :=true;
  
  }
  //Controls.Add(tChart1);
  Self.MinimizeBox := false;

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}

method MainForm.button1_Click(sender: System.Object; e: System.EventArgs);
begin
 // messagebox.Show(GetAppPath);
  if not System.IO.File.Exists(System.String.Format('{0}DbTest.sdf',GetAppPath)) then
  begin
 var ConStr: String := System.String.Format('data source=''{0}DbTest.sdf''',GetAppPath);
 using Engine: SqlCeEngine := new SqlCeEngine(ConStr) do
  Engine.CreateDatabase ;


using Con: SqlCeConnection := new SqlCeConnection(ConStr) do
 begin
    Con.Open;
    using Cmd: SqlCeCommand := new SqlCeCommand('create table test_table (test_field nvarchar(10))',Con) do
     begin
        Cmd.ExecuteNonQuery ;
        Cmd.CommandText := 'insert into test_table (test_field) values (''Test data'')';
        Cmd.ExecuteNonQuery ;
       end;
     end;
    Messagebox.Show(string.Format('Connected to {0}',ConStr));
   end;

end;

method MainForm.GetAppPath: String;
begin
   var temp : String := Self.GetType.Module.FullyQualifiedName ;
   var lastDir : Integer := temp.LastIndexOf ('\');
   Result := temp.Substring(0,lastdir + 1);

end;

method MainForm.button2_Click(sender: System.Object; e: System.EventArgs);
begin
  {
   Dim conn As New SqlCeConnection("Data Source = AdventureWorks.sdf")

   Dim selectCmd As SqlCeCommand = conn.CreateCommand()
   selectCmd.CommandText = "SELECT * FROM DimEmployee"

   Dim adp As New SqlCeDataAdapter(selectCmd)

   Dim ds As New DataSet()

   ' Note: Fill will leave the connection in its original state;
   ' In this case, the connection was closed so it will be left closed
   '
   adp.Fill(ds)
  }

  {
  http://msdn.microsoft.com/de-de/library/system.data.dataset.aspx
 Ein DataSet kann Daten sowie das Schema als XML-Dokumente lesen und schreiben. Die Daten und das Schema können dann über HTTP übertragen und von sämtlichen Anwendungen auf allen XML-fähigen Plattformen verwendet werden. Sie können das Schema mit der WriteXmlSchema-Methode als XML-Schema speichern. Das Schema und die Daten können mithilfe der WriteXml-Methode gespeichert werden. Verwenden Sie zum Lesen eines XML-Dokuments mit Schema und Daten die ReadXml-Methode.

In einer typischen Implementierung mit mehreren Ebenen werden die folgenden Schritte zum Erstellen und Aktualisieren eines DataSet und zum anschließenden Aktualisieren der ursprünglichen Daten ausgeführt:

   1. Erstellen Sie mithilfe eines DataAdapter jede DataTable in einem DataSet, und füllen Sie sie mit Daten aus einer Datenquelle.
   2. Ändern Sie die Daten in einzelnen DataTable-Objekten, indem Sie DataRow-Objekte hinzufügen, aktualisieren oder löschen.
   3. Rufen Sie die GetChanges-Methode auf, um ein zweites DataSet zu erstellen, das nur die Änderungen an den Daten darstellt.
   4. Rufen Sie die Update-Methode von DataAdapter auf, und übergeben Sie das zweite DataSet als Argument.
   5. Rufen Sie die Merge-Methode auf, um die Änderungen aus dem zweiten DataSet mit dem ersten zusammenzuführen.
   6. Rufen Sie AcceptChanges für das DataSet auf. Sie können auch RejectChanges aufrufen, um die Änderungen zu verwerfen. 
  }
  var ConStr: String := System.String.Format('data source=''{0}DbTest.sdf''',GetAppPath);
  using Con: SqlCeConnection := new SqlCeConnection(ConStr) do
    begin
    Con.Open; 
    using Cmd :SqlCeCommand := new SqlCeCommand('select * from test_table',Con) do
    begin
       var Da : SqlCeDataAdapter := new SqlCeDataAdapter(Cmd);
       var Ds : System.Data.DataSet := new System.Data.DataSet;
       Da.Fill(Ds);
       DataGrid1.DataSource := Ds.Tables [0];
      end;
    end;
end;

method MainForm.timer1_Tick(sender: System.Object; e: System.EventArgs);
begin
   var aktuell := DateTime.Today ;   
   var Jetzt_sec := DateTime.Now ;
  if aktuell.CompareTo(jetzt) > 0 then 
   begin
    monthCalendar1.TodayDate := aktuell.Date;
    monthCalendar1.Refresh ;
    Jetzt := datetime.Today ;
    end;
   TextBox1.Text := 'KW'+Kalenderwoche(Jetzt_sec).ToString + string.Format(' {0}',Jetzt_sec);

end;

method  MainForm.Kalenderwoche(datum :DateTime ): integer;
begin
  //var gbCulture : CultureInfo := new CultureInfo.InvariantCulture.Calendar ;
  var kalender : System.Globalization.Calendar := new System.Globalization.GregorianCalendar  ;
	result := kalender.GetWeekOfYear(datum,CalendarWeekRule.FirstFourDayWeek,DayOfWeek.Monday);
end;

method MainForm.MainForm_Load(sender: System.Object; e: System.EventArgs);
begin
  Jetzt := datetime.Today  ;
end;

method MainForm.monthCalendar1_DateChanged(sender: System.Object; e: System.Windows.Forms.DateRangeEventArgs);
begin
  
end;

method MainForm.button3_Click(sender: System.Object; e: System.EventArgs);
var line: Line;
    tChart1: TChart;
begin
  tChart1:= new TChart();
  Self.Controls.Add(tChart1);
  line := new Line(tChart1.Chart);
  line.FillSampleValues(10);
end;

end.